/*
 * table.h
 *
 * author: Roberto Piassi Passos Bodo
 *  email: rppbodo@gmail.com
 */

#ifndef table_h
#define table_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "global.h"

typedef struct node_t {
	long int delta_time;
	int tempo;
	struct node_t* next;
} Node_t;

typedef Node_t* Link_t;

Link_t head_t;

typedef struct node {
	long int delta_time;
	unsigned char bytes[3];
	struct node* next;
} Node;

typedef Node* Link;

Link* table;

int* events;

void init_table();

void insert_tempo(int delta_time, int tempo);

void print_tempo();

void insert_table(int track, int delta_time, unsigned char* bytes);

void print_table(int track);

int fix_soloist_track();

void finish_table();

#endif
